#ifndef PM_AUDIO_H
#define PM_AUDIO_H
#include <QThread>
#include <pulse/pulseaudio.h>

enum
{
	FD_TYPE_JACK = 0,
	FD_TYPE_POWER = 1
};

class pa_card
{
public:
	QString name;
	int idx;
};
class pm_thread : public QThread
{
public:
	pm_thread(int fd);
	void run();
	pa_context *context;
	pa_mainloop_api *mainloop_api;
	static void context_state_callback(pa_context *c, void *userdata);
	static void simple_callback(pa_context *c, int success, void *userdata);
	static void context_subscribe_callback(pa_context *c, pa_subscription_event_type_t t, uint32_t idx, void *userdata);
	static void get_card_info_callback(pa_context *c, const pa_card_info *i, int is_last, void *userdata);
	void   set_sink_port(const char *port, const char *value, int delay);
	void   set_sink_port(bool isplugged, int delay);
	void   set_source_port(const char *port, const char *value, int delay);
	void   set_source_port(bool isplugged, int delay);
	bool   connect_server(int max_try = 0);
	void   disconnect_server();
	QList<pa_card> cards;
	bool isconnected;
	int  ev_wait;
	int  ev_stop_loop_end;
	int  get_fd(){return fd;};
private:
	pa_mainloop *m;
	int fd;
};

int  jack_get_fd();
int  power_get_fd();
int  jack_get_ev_status(int fd,bool &isfound);
void input_process_event(int fd);
void jack_set_initial_values(int fd,int delay);

#endif
