#ifndef SD_DBUS_IFACE_H
#define SD_DBUS_IFACE_H
#include <QObject>
#include <QDBusServiceWatcher>
#include <QDBusObjectPath>
#include <QVariant>

class sd_dbus_iface : public QDBusServiceWatcher
{
Q_OBJECT 

	//Q_CLASSINFO("D-Bus Interface", "run.tpm3000")
public:
	sd_dbus_iface(QObject* parent=0);
	sd_dbus_iface* init_iface(QDBusConnection *);
	void register_on_properties();	
public slots:
	void on_UnitNew(const QString &in0, const QDBusObjectPath &in1);
	void on_UnitRemoved(const QString &in0, const QDBusObjectPath &in1);
	void on_JobNew(uint in0, const QDBusObjectPath &in1, const QString &in2);
    void on_JobRemoved(uint in0, const QDBusObjectPath &in1, const QString &in2, const QString &in3);
	void on_propertiesChanged(QString,QVariantMap,QStringList);
private:
	QDBusConnection *connectioni;
	QString unit_name;
};

int sd_bridge_init();
#endif
